<?php
declare (strict_types = 1);

namespace app\Admin\model;

use think\Model;

/**
 * @mixin \think\Model
 */
class AdminUser extends Model
{
    public function GetAccountByUid($uid){
        return $this->alias("a")->leftJoin("CFP_admin_account_relation b","a.id=b.account_id")->leftJoin("CFP_admin_user u","b.user_id=u.id")
            ->leftJoin("CFP_role r","b.role_id=r.id")->field("a.id,username,name,mobile,avatar,rolename,role_id,status")->where("u.id","=",$uid)
            ->find();
    }
}
