<?php
use think\facade\Route;

//
Route::rule('menu', 'Admin/Menu/MenuList');
Route::rule('menuadd', 'Admin/Menu/MenuAdd');
Route::rule('menusave', 'Admin/Menu/MenuEdit');
Route::rule('menudel', 'Admin/Menu/MenuDel');
Route::rule('menustatus', 'Admin/Menu/MenuStatus');
Route::rule('menuaction', 'Admin/Menu/ActionList');
Route::rule('menuactionsave', 'Admin/Menu/ActionSave');
Route::rule('menuactionstatus', 'Admin/Menu/ActionStatus');
Route::rule('menuactionadd', 'Admin/Menu/ActionAdd');
Route::rule("menulist","Admin/Menu/MenuAllList");

Route::rule('grouplist', 'Admin/Group/GroupList');
Route::rule('groupall', 'Admin/Group/GroupAll');
Route::rule('groupinfo', 'Admin/Group/GroupInfo');
Route::rule('groupadd', 'Admin/Group/GroupAdd');
Route::rule('groupsave', 'Admin/Group/GroupSave');
Route::rule('groupstatus', 'Admin/Group/GroupStatus');

Route::rule('rolelist', 'Admin/Role/RoleList');
Route::rule('roleall', 'Admin/Role/RoleAll');
Route::rule('roleinfo', 'Admin/Role/RoleInfo');
Route::rule('roleadd', 'Admin/Role/RoleAdd');
Route::rule('rolesave', 'Admin/Role/RoleSave');
Route::rule('rolestatus', 'Admin/Role/RoleStatus');

Route::rule("menuactionlist","Admin/Action/index");
Route::rule("actiondata","Admin/Action/DataAction");
Route::rule("actionsave","Admin/Action/ActionSave");
Route::rule("actionstatus","Admin/Action/ActionStatus");
Route::rule("actioninfo","Admin/Action/ActionInfo");
Route::rule("actionlist","Admin/Action/ActionList");

Route::rule("supplierlist","Admin/Supplier/SupplierList");
Route::rule("supplierinfo","Admin/Supplier/SupplierInfo");
Route::rule("suppliersave","Admin/Supplier/SupplierSave");
Route::rule("supplieradd","Admin/Supplier/SupplierAdd");
Route::rule("supplierstatus","Admin/Supplier/SupplierStatus");

Route::rule("paymentlist","Admin/Payment/PayList");
Route::rule("paymentadd","Admin/Payment/PayAdd");
Route::rule("paymentstatus","Admin/Payment/PayStatus");
Route::rule("paymentaduit","Admin/Payment/BusAduit");
Route::rule("paymentexam","Admin/Payment/PayExam");
Route::rule("paymentcgdlist","Admin/Payment/CgdList");
Route::rule("paymentpayinfo","Admin/Payment/PayInfo");
Route::rule("paymentpaysave","Admin/Payment/PaySave");
Route::rule("paymentcgdinv","Admin/Payment/CgdInv");
Route::rule("paymentcgdexam","Admin/Payment/CgdExam");
Route::rule("paymentinvreset","Admin/Payment/InvReset");
Route::rule("paymentthinfo","Admin/Payment/thinfo");
Route::rule("paymentunpay","Admin/Payment/UnPay");

Route::rule("upload","Admin/Upload/index");
Route::rule("cgdupload","Admin/Upload/CGDLoad");
Route::rule("QRDupload","Admin/Upload/QRDLoad");

Route::rule("loglist","Admin/System/index");
Route::rule("versionlist","Admin/System/version");
Route::rule("lastversion","Admin/System/LastVersion");

Route::rule("invoiceadd","Admin/Invoice/InvoiceAdd");
Route::rule("invoiceinfo","Admin/Invoice/index");
Route::rule("invoicesave","Admin/Invoice/InvoiceSave");
Route::rule("invoicedel","Admin/Invoice/InvoiceDel");
Route::rule("invoicecheck","Admin/Invoice/InvoiceCheck");
Route::rule("invoiceexam","Admin/Invoice/update");
Route::rule("invoicestatus","Admin/Invoice/InvoiceStatus");


Route::rule("companyinfo","Admin/Company/Info");
Route::rule("companyadd","Admin/Company/create");
Route::rule("companysave","Admin/Company/save");
Route::rule("companystatus","Admin/Company/status");
Route::rule("companylist","Admin/Company/list");
Route::rule("companyall","Admin/Company/all");
Route::rule("companyrela","Admin/Company/relation");
Route::rule("companydelrela","Admin/Company/DelRela");
Route::rule("ratelist","Admin/Company/RateList");

Route::rule("userinfo","Admin/User/userInfo");
Route::rule("userall","Admin/User/userAll");
Route::rule("userlist","Admin/User/userList");

Route::rule("sharelist","Admin/Share/index");
Route::rule("shareadd","Admin/Share/create");
Route::rule("sharesave","Admin/Share/save");
Route::rule("sharestatus","Admin/Share/status");
Route::rule("sharedel","Admin/Share/delete");
Route::rule("shareinfo","Admin/Share/read");

Route::rule("customerlist","Admin/Customer/list");
Route::rule("customerinfo","Admin/Customer/read");
Route::rule("customer","Admin/Customer/info");
Route::rule("invoicelist","Admin/Customer/invoice");

Route::rule("qrdlist","Admin/Confirm/list");

Route::rule("orderlist","Admin/Orderment/list");
Route::rule("orderadd","Admin/Orderment/create");
Route::rule("cwlist","Admin/Orderment/CWlist");

Route::rule("receiptcreate","Admin/Receipt/create");
Route::rule("receiptadd","Admin/Receipt/add");
Route::rule("receiptlist","Admin/Receipt/list");
Route::rule("receiptinfo","Admin/Receipt/read");
Route::rule("receiptdel","Admin/Receipt/delete");
Route::rule("receiptsave","Admin/Receipt/save");
Route::rule("receiptedit","Admin/Receipt/edit");
Route::rule("receiptstatus","Admin/Receipt/status");
Route::rule("receiptpost","Admin/Receipt/InvoPost");
Route::rule("getreceipt","Admin/Receipt/GetReceipt");
Route::rule("getreceiptlist","Admin/Receipt/recepitlist");
Route::rule("receiptbytrade","Admin/Receipt/CreateByTrade");
Route::rule("editbytrade","Admin/Receipt/EditByTrain");
Route::rule("receiptexport","Admin/Receipt/DownReceipt");
Route::rule("receiptimport","Admin/Receipt/ImportReceipt");

Route::rule("tradelist","Admin/Trade/list");
Route::rule("tradecreate","Admin/Trade/create");
Route::rule("tradesave","Admin/Trade/save");
Route::rule("tradepool","Admin/Trade/Poollist");
Route::rule("tradeinfo","Admin/Trade/read");
Route::rule("tradeupdate","Admin/Trade/update");
Route::rule("tradedel","Admin/Trade/delete");
Route::rule("tradein","Admin/Trade/info");
Route::rule("tradelog","Admin/Trade/TradeInfo");

Route::rule("assoccreate","Admin/Assoc/create");
Route::rule("assocadd","Admin/Assoc/add");
Route::rule("assoclist","Admin/Assoc/list");
Route::rule("assocexam","Admin/Assoc/edit");
Route::rule("associnfo","Admin/Assoc/read");
Route::rule("assocdel","Admin/Assoc/delete");
Route::rule("assocall","Admin/Assoc/GetList");
Route::rule("assocrela","Admin/Assoc/GetRelaList");

Route::rule("refundcreate","Admin/Refund/create");
Route::rule("refundlist","Admin/Refund/list");
Route::rule("refundexam","Admin/Refund/ExamStatus");
Route::rule("refundinfo","Admin/Refund/read");
Route::rule("refunddel","Admin/Refund/delete");

Route::rule("traderefund","Admin/Trade/SaveRefund");
Route::rule("refundbytrade","Admin/Assoc/RefundByTrade");
Route::rule("assocrefund","Admin/Assoc/AssocRefund");
Route::rule("assocrefundinv","Admin/Assoc/RefundAssocInv");
Route::rule("refundbyinv","Admin/Assoc/RefundByInv");
Route::rule("isrefund","Admin/Receipt/isRefund");
Route::rule("refundadd","Admin/Receipt/RefundAdd");
Route::rule("saverefundinv","Admin/Receipt/SaveRefundInv");
Route::rule("invrefundcreate","Admin/Receipt/InvRefundCreate");

Route::rule("downreportqrd","Admin/Report/downreportQRD");
Route::rule("downreportcgd","Admin/Report/downreportCGD");
Route::rule("downreportqrdtz","Admin/Report/downreportQRDTZ");
Route::rule("downreportcgdtz","Admin/Report/downreportCGDTZ");
Route::rule("downreportthtz","Admin/Report/downreportTHTZ");
Route::rule("downreportcw","Admin/Report/downreportCW");
Route::rule("downreportcwtz","Admin/Report/downreportCWTZ");
Route::rule("downqrd","Admin/Report/downQRD");
Route::rule("downcgd","Admin/Report/downCGD");
Route::rule("downqrdtz","Admin/Report/downQRDTZ");
Route::rule("downth","Admin/Report/downTH");
Route::rule("downqrdpay","Admin/Report/QRDPAY");
Route::rule("downqrdinv","Admin/Report/QRDINV");
Route::rule("jxreport","Admin/Report/jxreport");
Route::rule("jxthreport","Admin/Report/jxthreport");
Route::rule("outinreport","Admin/Report/OutInReport");
Route::rule("inforeport","Admin/Report/InfoReport");
Route::rule("invcomreport","Admin/Report/InvComReport");
Route::rule("invreport","Admin/Report/InvReport");

Route::rule("fhreport","Admin/Report/FhReport");
Route::rule("tzlist",'Admin/Tz/list');
Route::rule("tzinfo",'Admin/Tz/create');

Route::rule("execlist",'Admin/Exec/list');
Route::rule("execsave",'Admin/Exec/save');
Route::rule("execdown",'Admin/Exec/down');
Route::rule("nowlist",'Admin/Exec/nowlist');
Route::rule("execnowlist",'Admin/Exec/execlist');
Route::rule("execnowdown",'Admin/Exec/execdown');

Route::rule('interadd','Admin/Inter/add');
Route::rule('interinfo','Admin/Inter/info');
Route::rule('interlist','Admin/Inter/list');
Route::rule('intersave','Admin/Inter/edit');
Route::rule('getcat','Admin/Inter/getCat');
